searchNodes=[{"ref":"OpenTelemetry.html","title":"OpenTelemetry","type":"module","doc":"An OpenTelemetry Trace consists of 1 or more Spans that either have a parent/child relationship or are linked together through a Link. Each Span has a TraceId (trace_id/0), SpanId (span_id/0), and a start and end time in nanoseconds. This module provides declaration of the types used throughout the library, as well as functions for building the additional pieces of a span that are optional. Each item can be attached to individual Span using the functions in OpenTelemetry.Span module. Example require OpenTelemetry.Tracer require OpenTelemetry.Span OpenTelemetry.register_application_tracer(:this_otp_app) Tracer.start_span(&quot;some-span&quot;) ... event = &quot;ecto.query&quot; ecto_attributes = OpenTelemetry.event([{&quot;query&quot;, query}, {&quot;total_time&quot;, total_time}]) OpenTelemetry.Span.add_event(event, ecto_event) ... Tracer.end_span()"},{"ref":"OpenTelemetry.html#convert_timestamp/2","title":"OpenTelemetry.convert_timestamp/2","type":"function","doc":"Convert a native monotonic timestamp to POSIX time of any :erlang.time_unit/0. Meaning the time since Epoch. Epoch is defined to be 00:00:00 UTC, 1970-01-01."},{"ref":"OpenTelemetry.html#event/2","title":"OpenTelemetry.event/2","type":"function","doc":"Creates a event/0."},{"ref":"OpenTelemetry.html#event/3","title":"OpenTelemetry.event/3","type":"function","doc":"Creates a event/0."},{"ref":"OpenTelemetry.html#events/1","title":"OpenTelemetry.events/1","type":"function","doc":"Creates a list of event/0 items."},{"ref":"OpenTelemetry.html#get_tracer/1","title":"OpenTelemetry.get_tracer/1","type":"function","doc":"See :opentelemetry.get_tracer/1."},{"ref":"OpenTelemetry.html#link/1","title":"OpenTelemetry.link/1","type":"function","doc":"Creates a link/0 from a span_ctx/0."},{"ref":"OpenTelemetry.html#link/2","title":"OpenTelemetry.link/2","type":"function","doc":"Creates a link/0 from a span_ctx/0 and list of attributes/0."},{"ref":"OpenTelemetry.html#link/4","title":"OpenTelemetry.link/4","type":"function","doc":"Creates a link/0."},{"ref":"OpenTelemetry.html#links/1","title":"OpenTelemetry.links/1","type":"function","doc":"Creates a list of link/0 from a list of 4-tuples."},{"ref":"OpenTelemetry.html#register_application_meter/1","title":"OpenTelemetry.register_application_meter/1","type":"function","doc":"See :opentelemetry.register_application_meter/1."},{"ref":"OpenTelemetry.html#register_application_tracer/1","title":"OpenTelemetry.register_application_tracer/1","type":"function","doc":"Registering a Named Tracer with the name of an OTP Application enables each module in the Application to be mapped to the Named Tracer, named for the Application and using the version of the currently loaded Application by that name. Macros in OpenTelemetry.Tracer use the name of the module they are being used in in order to lookup the Named Tracer registered for that module and using it for trace operations."},{"ref":"OpenTelemetry.html#register_tracer/2","title":"OpenTelemetry.register_tracer/2","type":"function","doc":"See :opentelemetry.register_tracer/2."},{"ref":"OpenTelemetry.html#set_default_tracer/1","title":"OpenTelemetry.set_default_tracer/1","type":"function","doc":"See :opentelemetry.set_default_tracer/1."},{"ref":"OpenTelemetry.html#status/2","title":"OpenTelemetry.status/2","type":"function","doc":"Creates a Status."},{"ref":"OpenTelemetry.html#timestamp/0","title":"OpenTelemetry.timestamp/0","type":"function","doc":"A monotonically increasing time provided by the Erlang runtime system in the native time unit. This value is the most accurate and precise timestamp available from the Erlang runtime and should be used for finding durations or any timestamp that can be converted to a system time before being sent to another system. Use convert_timestamp/2 or timestamp_to_nano/1 to convert a native monotonic time to a system time of either nanoseconds or another unit. Using these functions allows timestamps to be accurate, used for duration and be exportable as POSIX time when needed."},{"ref":"OpenTelemetry.html#timestamp_to_nano/1","title":"OpenTelemetry.timestamp_to_nano/1","type":"function","doc":"Convert a native monotonic timestamp to nanosecond POSIX time. Meaning the time since Epoch. Epoch is defined to be 00:00:00 UTC, 1970-01-01."},{"ref":"OpenTelemetry.html#t:attribute_key/0","title":"OpenTelemetry.attribute_key/0","type":"type","doc":""},{"ref":"OpenTelemetry.html#t:attribute_value/0","title":"OpenTelemetry.attribute_value/0","type":"type","doc":""},{"ref":"OpenTelemetry.html#t:attributes/0","title":"OpenTelemetry.attributes/0","type":"type","doc":"Attributes are a collection of key/value pairs. The value can be a string, an integer, a double or the boolean values true or false. Note, global attributes like server name can be set using the resource API. Examples of attributes: [{&quot;/http/user_agent&quot; &quot;Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36&quot;} {&quot;/http/server_latency&quot;, 300} {&quot;abc.com/myattribute&quot;, True} {&quot;abc.com/score&quot;, 10.239}]"},{"ref":"OpenTelemetry.html#t:event/0","title":"OpenTelemetry.event/0","type":"type","doc":"An Event is a time-stamped annotation of the span, consisting of user-supplied text description and key-value pairs."},{"ref":"OpenTelemetry.html#t:event_name/0","title":"OpenTelemetry.event_name/0","type":"type","doc":""},{"ref":"OpenTelemetry.html#t:link/0","title":"OpenTelemetry.link/0","type":"type","doc":"A Link is a pointer from the current span to another span in the same trace or in a different trace. For example, this can be used in batching operations, where a single batch handler processes multiple requests from different traces or when the handler receives a request from a different project."},{"ref":"OpenTelemetry.html#t:links/0","title":"OpenTelemetry.links/0","type":"type","doc":""},{"ref":"OpenTelemetry.html#t:span/0","title":"OpenTelemetry.span/0","type":"type","doc":"Span represents a single operation within a trace. Spans can be nested to form a trace tree. Spans may also be linked to other spans from the same or different trace and form graphs. Often, a trace contains a root span that describes the end-to-end latency, and one or more subspans for its sub-operations. A trace can also contain multiple root spans, or none at all. Spans do not need to be contiguous - there may be gaps or overlaps between spans in a trace."},{"ref":"OpenTelemetry.html#t:span_ctx/0","title":"OpenTelemetry.span_ctx/0","type":"type","doc":"A SpanContext represents the portion of a Span needed to do operations on a Span. Within a process it acts as a key for looking up and modifying the actual Span. It is also what is serialized and propagated across process boundaries."},{"ref":"OpenTelemetry.html#t:span_id/0","title":"OpenTelemetry.span_id/0","type":"type","doc":"SpanId is a unique identifier for a span within a trace, assigned when the span is created. The ID is an 8-byte array. An ID with all zeroes is considered invalid."},{"ref":"OpenTelemetry.html#t:span_kind/0","title":"OpenTelemetry.span_kind/0","type":"type","doc":""},{"ref":"OpenTelemetry.html#t:status/0","title":"OpenTelemetry.status/0","type":"type","doc":"An optional final status for this span. Semantically when Status wasn't set it means span ended without errors and assume Ok."},{"ref":"OpenTelemetry.html#t:trace_id/0","title":"OpenTelemetry.trace_id/0","type":"type","doc":"TraceId is a unique identifier for a trace. All spans from the same trace share the same trace_id. The ID is a 16-byte array. An ID with all zeroes is considered invalid."},{"ref":"OpenTelemetry.html#t:tracer_ctx/0","title":"OpenTelemetry.tracer_ctx/0","type":"type","doc":"TracerContext refers to the data kept in process by the tracer to track the current SpanContext and the parent."},{"ref":"OpenTelemetry.html#t:tracestate/0","title":"OpenTelemetry.tracestate/0","type":"type","doc":"Tracestate represents tracing-system specific context in a list of key-value pairs. Tracestate allows different vendors propagate additional information and inter-operate with their legacy Id formats. It is a tracestate in the w3c-trace-context format. See also https://github.com/w3c/distributed-tracing for more details about this field."},{"ref":"OpenTelemetry.Baggage.html","title":"OpenTelemetry.Baggage","type":"module","doc":"Baggage is used to annotate telemetry, adding context and information to metrics, traces, and logs. It is represented by a set of name/value pairs describing user-defined properties."},{"ref":"OpenTelemetry.Baggage.html#clear/0","title":"OpenTelemetry.Baggage.clear/0","type":"function","doc":"See :otel_baggage.clear/0."},{"ref":"OpenTelemetry.Baggage.html#get_all/0","title":"OpenTelemetry.Baggage.get_all/0","type":"function","doc":"See :otel_baggage.get_all/0."},{"ref":"OpenTelemetry.Baggage.html#get_text_map_propagators/0","title":"OpenTelemetry.Baggage.get_text_map_propagators/0","type":"function","doc":"See :otel_baggage.get_text_map_propagators/0."},{"ref":"OpenTelemetry.Baggage.html#set/1","title":"OpenTelemetry.Baggage.set/1","type":"function","doc":"See :otel_baggage.set/1."},{"ref":"OpenTelemetry.Baggage.html#set/2","title":"OpenTelemetry.Baggage.set/2","type":"function","doc":"See :otel_baggage.set/2."},{"ref":"OpenTelemetry.Counter.html","title":"OpenTelemetry.Counter","type":"module","doc":"require OpenTelemetry.Counter OpenTelemetry.Counter.new(&quot;some.counter&quot;) OpenTelemetry.Counter.add(&quot;some.counter&quot;, 3)"},{"ref":"OpenTelemetry.Counter.html#add/2","title":"OpenTelemetry.Counter.add/2","type":"macro","doc":""},{"ref":"OpenTelemetry.Counter.html#add/3","title":"OpenTelemetry.Counter.add/3","type":"macro","doc":""},{"ref":"OpenTelemetry.Counter.html#definition/2","title":"OpenTelemetry.Counter.definition/2","type":"function","doc":"See :otel_counter.definition/2."},{"ref":"OpenTelemetry.Counter.html#measurement/2","title":"OpenTelemetry.Counter.measurement/2","type":"function","doc":"See :otel_counter.measurement/2."},{"ref":"OpenTelemetry.Counter.html#new/2","title":"OpenTelemetry.Counter.new/2","type":"macro","doc":""},{"ref":"OpenTelemetry.Ctx.html","title":"OpenTelemetry.Ctx","type":"module","doc":"Ctx is responsible for propagating values within a process that are associated with a particular Trace or set of Baggage. OpenTelemetry.Tracer and OpenTelemetry.Baggage handle updating the Context."},{"ref":"OpenTelemetry.Ctx.html#attach/1","title":"OpenTelemetry.Ctx.attach/1","type":"function","doc":"See :otel_ctx.attach/1."},{"ref":"OpenTelemetry.Ctx.html#clear/0","title":"OpenTelemetry.Ctx.clear/0","type":"function","doc":"See :otel_ctx.clear/0."},{"ref":"OpenTelemetry.Ctx.html#detach/1","title":"OpenTelemetry.Ctx.detach/1","type":"function","doc":"See :otel_ctx.detach/1."},{"ref":"OpenTelemetry.Ctx.html#get_current/0","title":"OpenTelemetry.Ctx.get_current/0","type":"function","doc":"See :otel_ctx.get_current/0."},{"ref":"OpenTelemetry.Ctx.html#get_value/2","title":"OpenTelemetry.Ctx.get_value/2","type":"function","doc":"See :otel_ctx.get_value/2."},{"ref":"OpenTelemetry.Ctx.html#get_value/3","title":"OpenTelemetry.Ctx.get_value/3","type":"function","doc":"See :otel_ctx.get_value/3."},{"ref":"OpenTelemetry.Ctx.html#new/0","title":"OpenTelemetry.Ctx.new/0","type":"function","doc":"See :otel_ctx.new/0."},{"ref":"OpenTelemetry.Ctx.html#remove/1","title":"OpenTelemetry.Ctx.remove/1","type":"function","doc":"See :otel_ctx.remove/1."},{"ref":"OpenTelemetry.Ctx.html#set_value/2","title":"OpenTelemetry.Ctx.set_value/2","type":"function","doc":"See :otel_ctx.set_value/2."},{"ref":"OpenTelemetry.Ctx.html#set_value/3","title":"OpenTelemetry.Ctx.set_value/3","type":"function","doc":"See :otel_ctx.set_value/3."},{"ref":"OpenTelemetry.Meter.html","title":"OpenTelemetry.Meter","type":"module","doc":"require OpenTelemetry.ValueRecorder require OpenTelemetry.Counter require OpenTelemetry.Meter OpenTelemetry.register_application_meter(Your.Application) OpenTelemetry.Meter.new_instruments([OpenTelemetry.ValueRecorder.instrument(&quot;some.latency&quot;), OpenTelemetry.Counter.instrument(&quot;some.counter&quot;)]) # use the new instrument by name OpenTelemetry.Counter.add(&quot;some.counter&quot;, 1) # or use a bound instrument bound = OpenTelemetry.Meter.bind(&quot;some.latency&quot;, []) # measure time spent on some function and then record it OpenTelemetry.ValueRecorder.record(bound, time)"},{"ref":"OpenTelemetry.Meter.html#bind/2","title":"OpenTelemetry.Meter.bind/2","type":"macro","doc":""},{"ref":"OpenTelemetry.Meter.html#new_instruments/1","title":"OpenTelemetry.Meter.new_instruments/1","type":"macro","doc":""},{"ref":"OpenTelemetry.Meter.html#record/2","title":"OpenTelemetry.Meter.record/2","type":"macro","doc":""},{"ref":"OpenTelemetry.Meter.html#record/3","title":"OpenTelemetry.Meter.record/3","type":"macro","doc":""},{"ref":"OpenTelemetry.Meter.html#record_batch/2","title":"OpenTelemetry.Meter.record_batch/2","type":"macro","doc":""},{"ref":"OpenTelemetry.Meter.html#release/1","title":"OpenTelemetry.Meter.release/1","type":"macro","doc":""},{"ref":"OpenTelemetry.Span.html","title":"OpenTelemetry.Span","type":"module","doc":"This module contains macros for Span operations that update the active current Span in the current process. An example of creating an Event and adding it to the current Span: require OpenTelemetry.Span ... event = &quot;ecto.query&quot; ecto_attributes = OpenTelemetry.event([{&quot;query&quot;, query}, {&quot;total_time&quot;, total_time}]) OpenTelemetry.Span.add_event(event, ecto_attributes) ... A Span represents a single operation within a trace. Spans can be nested to form a trace tree. Each trace contains a root span, which typically describes the end-to-end latency and, optionally, one or more sub-spans for its sub-operations. Spans encapsulate: The span name An immutable SpanContext (OpenTelemetry.span_ctx/0) that uniquely identifies the Span A parent Span in the form of a Span (OpenTelemetry.span/0), SpanContext (OpenTelemetry.span_ctx/0), or undefined A start timestamp An end timestamp An ordered mapping of Attributes (OpenTelemetry.attributes/0) A list of Links to other Spans (OpenTelemetry.link/0) A list of timestamped Events (OpenTelemetry.event/0) A Status (OpenTelemetry.status/0)"},{"ref":"OpenTelemetry.Span.html#add_event/3","title":"OpenTelemetry.Span.add_event/3","type":"function","doc":"Add an event to the currently active Span."},{"ref":"OpenTelemetry.Span.html#add_events/2","title":"OpenTelemetry.Span.add_events/2","type":"function","doc":"Add a list of events to the currently active Span."},{"ref":"OpenTelemetry.Span.html#end_span/1","title":"OpenTelemetry.Span.end_span/1","type":"function","doc":"End the Span. Sets the end timestamp for the currently active Span. This has no effect on any child Spans that may exist of this Span. The Span Context is returned with is_recording set to false."},{"ref":"OpenTelemetry.Span.html#set_attribute/3","title":"OpenTelemetry.Span.set_attribute/3","type":"function","doc":"Set an attribute with key and value on the currently active Span."},{"ref":"OpenTelemetry.Span.html#set_attributes/2","title":"OpenTelemetry.Span.set_attributes/2","type":"function","doc":"Add a list of attributes to the currently active Span."},{"ref":"OpenTelemetry.Span.html#set_status/2","title":"OpenTelemetry.Span.set_status/2","type":"function","doc":"Sets the Status of the currently active Span. If used, this will override the default Span Status, which is Ok."},{"ref":"OpenTelemetry.Span.html#span_id/1","title":"OpenTelemetry.Span.span_id/1","type":"function","doc":"Get the SpanId of a Span."},{"ref":"OpenTelemetry.Span.html#trace_id/1","title":"OpenTelemetry.Span.trace_id/1","type":"function","doc":"Get the TraceId of a Span."},{"ref":"OpenTelemetry.Span.html#tracestate/1","title":"OpenTelemetry.Span.tracestate/1","type":"function","doc":"Get the Tracestate of a Span."},{"ref":"OpenTelemetry.Span.html#update_name/2","title":"OpenTelemetry.Span.update_name/2","type":"function","doc":"Updates the Span name. It is highly discouraged to update the name of a Span after its creation. Span name is often used to group, filter and identify the logical groups of spans. And often, filtering logic will be implemented before the Span creation for performance reasons. Thus the name update may interfere with this logic. The function name is called UpdateName to differentiate this function from the regular property setter. It emphasizes that this operation signifies a major change for a Span and may lead to re-calculation of sampling or filtering decisions made previously depending on the implementation."},{"ref":"OpenTelemetry.SumObserver.html","title":"OpenTelemetry.SumObserver","type":"module","doc":"require OpenTelemetry.SumObserver OpenTelemetry.SumObserver.set_callback(&quot;some.counter&quot;, &amp;OpenTelemetry.SumObserver.observe(&amp;1, 33, []))"},{"ref":"OpenTelemetry.SumObserver.html#definition/2","title":"OpenTelemetry.SumObserver.definition/2","type":"function","doc":"See :otel_sum_observer.definition/2."},{"ref":"OpenTelemetry.SumObserver.html#new/2","title":"OpenTelemetry.SumObserver.new/2","type":"macro","doc":""},{"ref":"OpenTelemetry.SumObserver.html#observe/3","title":"OpenTelemetry.SumObserver.observe/3","type":"function","doc":"See :otel_sum_observer.observe/3."},{"ref":"OpenTelemetry.SumObserver.html#set_callback/2","title":"OpenTelemetry.SumObserver.set_callback/2","type":"macro","doc":""},{"ref":"OpenTelemetry.Tracer.html","title":"OpenTelemetry.Tracer","type":"module","doc":"This module contains macros for Tracer operations around the lifecycle of the Spans within a Trace. The Tracer is able to start a new Span as a child of the active Span of the current process, set a different Span to be the current Span by passing the Span's context, end a Span or run a code block within the context of a newly started span that is ended when the code block completes. The macros use the Tracer registered to the Application the module using the macro is included in, assuming OpenTelemetry.register_application_tracer/1 has been called for the Application. If not then the default Tracer is used. require OpenTelemetry.Tracer OpenTelemetry.Tracer.with_span &quot;span-1&quot; do ... do something ... end"},{"ref":"OpenTelemetry.Tracer.html#add_event/2","title":"OpenTelemetry.Tracer.add_event/2","type":"function","doc":"Add an event to the currently active Span."},{"ref":"OpenTelemetry.Tracer.html#add_events/1","title":"OpenTelemetry.Tracer.add_events/1","type":"function","doc":"Add a list of events to the currently active Span."},{"ref":"OpenTelemetry.Tracer.html#current_span_ctx/0","title":"OpenTelemetry.Tracer.current_span_ctx/0","type":"function","doc":"Returns the currently active OpenTelemetry.span_ctx/0."},{"ref":"OpenTelemetry.Tracer.html#end_span/0","title":"OpenTelemetry.Tracer.end_span/0","type":"function","doc":"End the Span. Sets the end timestamp for the currently active Span. This has no effect on any child Spans that may exist of this Span. The Span in the current Context has its is_recording set to false."},{"ref":"OpenTelemetry.Tracer.html#set_attribute/2","title":"OpenTelemetry.Tracer.set_attribute/2","type":"function","doc":"Set an attribute with key and value on the currently active Span."},{"ref":"OpenTelemetry.Tracer.html#set_attributes/1","title":"OpenTelemetry.Tracer.set_attributes/1","type":"function","doc":"Add a list of attributes to the currently active Span."},{"ref":"OpenTelemetry.Tracer.html#set_current_span/1","title":"OpenTelemetry.Tracer.set_current_span/1","type":"function","doc":"Takes a OpenTelemetry.span_ctx/0 and the Tracer sets it to the currently active Span."},{"ref":"OpenTelemetry.Tracer.html#set_status/1","title":"OpenTelemetry.Tracer.set_status/1","type":"function","doc":"Sets the Status of the currently active Span. If used, this will override the default Span Status, which is Ok."},{"ref":"OpenTelemetry.Tracer.html#start_span/2","title":"OpenTelemetry.Tracer.start_span/2","type":"macro","doc":"Starts a new span and does not make it the current active span of the current process. The current active Span is used as the parent of the created Span unless a parent is given in the start_opts/0 argument or there is no active Span. If there is neither a current Span or a parent option given then the Tracer checks for an extracted SpanContext to use as the parent. If there is also no extracted context then the created Span is a root Span."},{"ref":"OpenTelemetry.Tracer.html#update_name/1","title":"OpenTelemetry.Tracer.update_name/1","type":"function","doc":"Updates the Span name. It is highly discouraged to update the name of a Span after its creation. Span name is often used to group, filter and identify the logical groups of spans. And often, filtering logic will be implemented before the Span creation for performance reasons. Thus the name update may interfere with this logic. The function name is called UpdateName to differentiate this function from the regular property setter. It emphasizes that this operation signifies a major change for a Span and may lead to re-calculation of sampling or filtering decisions made previously depending on the implementation."},{"ref":"OpenTelemetry.Tracer.html#with_span/3","title":"OpenTelemetry.Tracer.with_span/3","type":"macro","doc":"Creates a new span which is set to the currently active Span in the Context of the block. The Span is ended automatically when the block completes and the Context is what it was before the block. See start_span/2 and end_span/0."},{"ref":"OpenTelemetry.Tracer.html#t:start_opts/0","title":"OpenTelemetry.Tracer.start_opts/0","type":"type","doc":""},{"ref":"OpenTelemetry.UpdownCounter.html","title":"OpenTelemetry.UpdownCounter","type":"module","doc":"require OpenTelemetry.UpdownCounter OpenTelemetry.UpdownCounter.new(&quot;some.counter&quot;) OpenTelemetry.UpdownCounter.add(&quot;some.counter&quot;, -3)"},{"ref":"OpenTelemetry.UpdownCounter.html#add/2","title":"OpenTelemetry.UpdownCounter.add/2","type":"macro","doc":""},{"ref":"OpenTelemetry.UpdownCounter.html#add/3","title":"OpenTelemetry.UpdownCounter.add/3","type":"macro","doc":""},{"ref":"OpenTelemetry.UpdownCounter.html#definition/2","title":"OpenTelemetry.UpdownCounter.definition/2","type":"function","doc":"See :otel_updown_counter.definition/2."},{"ref":"OpenTelemetry.UpdownCounter.html#measurement/2","title":"OpenTelemetry.UpdownCounter.measurement/2","type":"function","doc":"See :otel_updown_counter.measurement/2."},{"ref":"OpenTelemetry.UpdownCounter.html#new/2","title":"OpenTelemetry.UpdownCounter.new/2","type":"macro","doc":""},{"ref":"OpenTelemetry.UpdownSumObserver.html","title":"OpenTelemetry.UpdownSumObserver","type":"module","doc":"require OpenTelemetry.UpdownSumObserver OpenTelemetry.UpdownSumObserver.set_callback(&quot;some.counter&quot;, OpenTelemetry.UpdownSumObserver.observe(&amp;1, -33, []))"},{"ref":"OpenTelemetry.UpdownSumObserver.html#definition/2","title":"OpenTelemetry.UpdownSumObserver.definition/2","type":"function","doc":"See :otel_updown_sum_observer.definition/2."},{"ref":"OpenTelemetry.UpdownSumObserver.html#new/2","title":"OpenTelemetry.UpdownSumObserver.new/2","type":"macro","doc":""},{"ref":"OpenTelemetry.UpdownSumObserver.html#observe/3","title":"OpenTelemetry.UpdownSumObserver.observe/3","type":"function","doc":"See :otel_updown_sum_observer.observe/3."},{"ref":"OpenTelemetry.UpdownSumObserver.html#set_callback/2","title":"OpenTelemetry.UpdownSumObserver.set_callback/2","type":"macro","doc":""},{"ref":"OpenTelemetry.ValueObserver.html","title":"OpenTelemetry.ValueObserver","type":"module","doc":"require OpenTelemetry.ValueObserver OpenTelemetry.ValueObserver.set_callback(&quot;some.counter&quot;, fn o -&gt; OpenTelemetry.ValueObserver.observe(o, 33, []))"},{"ref":"OpenTelemetry.ValueObserver.html#definition/2","title":"OpenTelemetry.ValueObserver.definition/2","type":"function","doc":"See :otel_value_observer.definition/2."},{"ref":"OpenTelemetry.ValueObserver.html#new/2","title":"OpenTelemetry.ValueObserver.new/2","type":"macro","doc":""},{"ref":"OpenTelemetry.ValueObserver.html#observe/3","title":"OpenTelemetry.ValueObserver.observe/3","type":"function","doc":"See :otel_value_observer.observe/3."},{"ref":"OpenTelemetry.ValueObserver.html#set_callback/2","title":"OpenTelemetry.ValueObserver.set_callback/2","type":"macro","doc":""},{"ref":"OpenTelemetry.ValueRecorder.html","title":"OpenTelemetry.ValueRecorder","type":"module","doc":"require OpenTelemetry.ValueRecorder OpenTelemetry.ValueRecorder.record(&quot;some.recorder&quot;, 3)"},{"ref":"OpenTelemetry.ValueRecorder.html#definition/2","title":"OpenTelemetry.ValueRecorder.definition/2","type":"function","doc":"See :otel_value_recorder.definition/2."},{"ref":"OpenTelemetry.ValueRecorder.html#measurement/2","title":"OpenTelemetry.ValueRecorder.measurement/2","type":"function","doc":"See :otel_value_recorder.measurement/2."},{"ref":"OpenTelemetry.ValueRecorder.html#new/2","title":"OpenTelemetry.ValueRecorder.new/2","type":"macro","doc":""},{"ref":"OpenTelemetry.ValueRecorder.html#record/2","title":"OpenTelemetry.ValueRecorder.record/2","type":"macro","doc":""},{"ref":"OpenTelemetry.ValueRecorder.html#record/3","title":"OpenTelemetry.ValueRecorder.record/3","type":"macro","doc":""},{"ref":"readme.html","title":"Overview","type":"extras","doc":"Erlang/Elixir OpenTelemetry API This is the API portion of OpenTelemetry for Erlang and Elixir Applications. This is a library, it does not start any processes, and should be the only OpenTelemetry dependency of Erlang/Elixir Applications. The end user of your Application can then choose to include the OpenTelemetry implementation Application. If the implementation Application is not in the final release the OpenTelemetry instrumentation will all be no-ops. This means no processes started, no ETS tables created and nothing added to the process dictionary. This separation is done so you should feel comfortable instrumenting your Erlang/Elixir Application with OpenTelemetry and not worry that a complicated dependency is being forced on your users."},{"ref":"readme.html#use","title":"Overview - Use","type":"extras","doc":"When instrumenting an Application to be used as a dependency of other projects it is best practice to register a Tracer with a name and a version using the Application's name and version. This should be the name and version of the Application that has the opentelemetry calls being written in it, not the name of the Application it might be being used to instrument. For example, an Elli middleware to add tracing to the Elli HTTP server would not be named elli, it would be the name of the middleware Application, like opentelemetry_elli. Registration is done through a single process and uses a persistent_term, so should be done only once per-Application. Updating a registration is allowed, so updating the version on a release upgrade can, and should, be done, but will involve the performance penalty of updating a persistent_term. Naming the Tracers provides additional metadata on spans and allows the user of your Application to disable the traces from the dependency if it is needed. Dependency in Elixir def deps do [ {:opentelemetry_api, &quot;~&gt; 0.3.0&quot;} ] end Registering and Using Tracers Directly If it is a runnable application then this registration should happen in start/2, example below is adding Tracer registration to the Postgres library pgo: start(_StartType, _StartArgs) -&gt; _ = opentelemetry:register_application_tracer(pgo), ... Or for an Elixir Application named MyApp: defmodule MyApp do use Application def start(_type, _args) do _ = OpenTelemetry.register_application_tracer(:my_app) ... end end Then when the spans are started and finished in the application's code the Tracer is fetched with get_tracer/1 and passed to with_span/3 or start_span/3: Tracer = opentelemetry:get_tracer(pgo), otel_tracer:with_span(Tracer, &lt;&lt;&quot;pgo:query/3&quot;&gt;&gt;, fun() -&gt; ... end). A Tracer variable can be passed through your Application's calls so get_tracer only has to be called once, it is safe to store it in the state of a gen_server and to pass across process boundaries. If the application does not have a start/2 there may be another function that is always called before the library would create any spans. For example, the Elli middleware for OpenTelemetry instrumentation registers the Tracer during Elli startup: handle_event(elli_startup, _Args, _Config) -&gt; _ = opentelemetry:register_application_tracer(opentelemetry_elli), ok; When there is no startup of any kind to hook into in the library itself it should export a function register_application_tracer/0 to be used by any application that depends on it to do the registration: -module(mylib). -export([register_tracer/0]). register_tracer() -&gt; _ = opentelemetry:register_application_tracer(mylib), ok. Not registering does not cause any issues or crashes, OpenTelemetry simply will fallback to the default Tracer if get_tracer/1 is called with a name that is not registered. Helper Macros for Application Tracers When register_application_tracer/1 is used to register a Tracer there are both Erlang and Elixir macros that make use of the current module's name to lookup the Tracer for you and can be used for Trace and Span operations: -include_lib(&quot;opentelemetry_api/include/otel_tracer.hrl&quot;). some_fun() -&gt; ?with_span(&lt;&lt;&quot;some_fun/0&quot;&gt;&gt;, \#{}, fun(_SpanCtx) -&gt; ... ?set_attribute(&lt;&lt;&quot;key&quot;&gt;&gt;, &lt;&lt;&quot;value&quot;&gt;&gt;), ... end), require OpenTelemetry.Tracer require OpenTelemetry.Span def some_fun() do OpenTelemetry.Tracer.with_span &quot;some-span&quot; do ... OpenTelemetry.Span.set_attribute(&quot;key&quot;, &quot;value&quot;) ... end end Including the OpenTelemetry SDK For traces to actually be tracked, propagated and exported, the opentelemetry Application must be included as a dependency of your project, likely as part of a Release and not as a dependency of an individual Application within the Release. See the Using section of the OpenTelemetry-Erlang repository for details. Exporters Exporters can be found as separate Applications on Github under the OpenTelemetry Beam Organization. Zipkin OpenTelemetry Collector HTTP Integrations Elli Database Client Integration Ecto"},{"ref":"readme.html#contributing","title":"Overview - Contributing","type":"extras","doc":"See the contributing file."},{"ref":"opentelemetry.html","title":"opentelemetry","type":"extras","doc":"Module opentelemetry Description Data Types Function Index Function Details The types defined here, and referencing records in opentelemetry.hrl are used to store trace information while being collected on the Erlang node."},{"ref":"opentelemetry.html#description","title":"opentelemetry - Description","type":"extras","doc":"Thus, while the types are based on protos found in the opentelemetry-proto repo: src/opentelemetry/proto/trace/v1/trace.proto, they are not exact translations because further processing is done after the span has finished and can be vendor specific. For example, there is no count of the number of dropped attributes in the span record. And an attribute's value can be a function to only evaluate the value if it is actually used (at the time of exporting). And the stacktrace is a regular Erlang stack trace."},{"ref":"opentelemetry.html#data-types","title":"opentelemetry - Data Types","type":"extras","doc":"attribute() attribute_key() attribute_value() attributes() event() event_name() events() link() links() meter() resource() span() span_ctx() span_id() span_kind() span_name() status() status_code() text_map() timestamp() trace_flags() trace_id() tracer() tracestate()"},{"ref":"opentelemetry.html#function-index","title":"opentelemetry - Function Index","type":"extras","doc":""},{"ref":"opentelemetry.html#function-details","title":"opentelemetry - Function Details","type":"extras","doc":"convert_timestamp/2 Convert a native monotonic timestamp to POSIX time of any erlang:time_unit(). Meaning the time since Epoch. Epoch is defined to be 00:00:00 UTC, 1970-01-01. event/2 event/3 events/1 events(List) -&gt; any() generate_span_id/0 Generates a 64 bit random integer to use as a span id. generate_trace_id/0 Generates a 128 bit random integer to use as a trace id. get_meter/0 get_meter/1 get_text_map_extractors/0 get_text_map_extractors() -&gt; any() get_text_map_injectors/0 get_text_map_injectors() -&gt; any() get_tracer/0 get_tracer/1 link/1 link/2 link/4 links/1 register_application_meter/1 register_application_tracer/1 register_meter/2 register_tracer/2 set_default_meter/1 set_default_tracer/1 set_meter/2 set_text_map_extractors/1 set_text_map_extractors(List) -&gt; any() set_text_map_injectors/1 set_text_map_injectors(List) -&gt; any() set_tracer/2 status/2 timestamp/0 A monotonically increasing time provided by the Erlang runtime system in the native time unit. This value is the most accurate and precise timestamp available from the Erlang runtime and should be used for finding durations or any timestamp that can be converted to a system time before being sent to another system. timestamp_to_nano/1 Convert a native monotonic timestamp to nanosecond POSIX time. Meaning the time since Epoch. Epoch is defined to be 00:00:00 UTC, 1970-01-01."},{"ref":"otel_baggage.html","title":"otel_baggage","type":"extras","doc":"Module otel_baggage Description Data Types Function Index Function Details Baggage is used to annotate telemetry, adding context and information to metrics, traces, and logs."},{"ref":"otel_baggage.html#description","title":"otel_baggage - Description","type":"extras","doc":"It is represented by a set of name/value pairs describing user-defined properties."},{"ref":"otel_baggage.html#data-types","title":"otel_baggage - Data Types","type":"extras","doc":"key() t() value()"},{"ref":"otel_baggage.html#function-index","title":"otel_baggage - Function Index","type":"extras","doc":""},{"ref":"otel_baggage.html#function-details","title":"otel_baggage - Function Details","type":"extras","doc":"clear/0 get_all/0 get_text_map_propagators/0 set/1 set/2"},{"ref":"otel_counter.html","title":"otel_counter","type":"extras","doc":"Module otel_counter Function Index Function Details Behaviours: otel_instrument."},{"ref":"otel_counter.html#function-index","title":"otel_counter - Function Index","type":"extras","doc":""},{"ref":"otel_counter.html#function-details","title":"otel_counter - Function Details","type":"extras","doc":"add/2 add/4 definition/1 definition/2 measurement/2 new/2 new/3"},{"ref":"otel_ctx.html","title":"otel_ctx","type":"extras","doc":"Module otel_ctx Description Data Types Function Index Function Details Ctx is responsible for propagating values within a process that are associated with a particular Trace or set of Baggage."},{"ref":"otel_ctx.html#description","title":"otel_ctx - Description","type":"extras","doc":"OpenTelemetry.Tracer and OpenTelemetry.Baggage handle updating the Context."},{"ref":"otel_ctx.html#data-types","title":"otel_ctx - Data Types","type":"extras","doc":"key() t() token() value()"},{"ref":"otel_ctx.html#function-index","title":"otel_ctx - Function Index","type":"extras","doc":""},{"ref":"otel_ctx.html#function-details","title":"otel_ctx - Function Details","type":"extras","doc":"attach/1 clear/0 detach/1 get_current/0 get_value/1 get_value/2 get_value/3 new/0 remove/1 set_value/2 set_value/3 text_map_extractor/2 text_map_extractor(Key, FromText) -&gt; any() text_map_extractor_fun/3 text_map_extractor_fun(TextMap, Key, FromText) -&gt; any() text_map_injector/2 text_map_injector(Key, ToText) -&gt; any() text_map_injector_fun/3 text_map_injector_fun(TextMap, Key, ToText) -&gt; any()"},{"ref":"otel_instrument.html","title":"otel_instrument","type":"extras","doc":"Module otel_instrument Description All measurements are associated with an instrument. This module defines the otel_instrument behaviour. Required callback functions: new/2, new/3, definition/1, definition/2."},{"ref":"otel_instrument.html#description","title":"otel_instrument - Description","type":"extras","doc":"To record measurements for an instrument it must first be created with new and then can be referenced by name."},{"ref":"otel_meter.html","title":"otel_meter","type":"extras","doc":"Module otel_meter Data Types Function Index Function Details This module defines the otel_meter behaviour. Required callback functions: new_instrument/4, new_instruments/2, record/3, record/4, record_batch/3, bind/3, release/2, register_observer/3, set_observer_callback/3, observe/3."},{"ref":"otel_meter.html#data-types","title":"otel_meter - Data Types","type":"extras","doc":"bound_instrument() description() instrument_config() instrument_definition() instrument_kind() instrument_opts() instrument_properties() label() label_key() label_value() labels() measurement() name() number_kind() unit()"},{"ref":"otel_meter.html#function-index","title":"otel_meter - Function Index","type":"extras","doc":""},{"ref":"otel_meter.html#function-details","title":"otel_meter - Function Details","type":"extras","doc":"bind/3 instrument_definition/4 new_instrument/4 new_instruments/2 observe/3 record/2 record/4 record_batch/3 register_observer/3 release/1 set_observer_callback/3"},{"ref":"otel_meter_noop.html","title":"otel_meter_noop","type":"extras","doc":"Module otel_meter_noop Function Index Function Details Behaviours: otel_meter."},{"ref":"otel_meter_noop.html#function-index","title":"otel_meter_noop - Function Index","type":"extras","doc":""},{"ref":"otel_meter_noop.html#function-details","title":"otel_meter_noop - Function Details","type":"extras","doc":"bind/3 bind(X1, X2, X3) -&gt; any() labels/2 labels(X1, X2) -&gt; any() new_instrument/4 new_instrument(X1, X2, X3, X4) -&gt; any() new_instruments/2 new_instruments(X1, X2) -&gt; any() observe/3 observe(X1, X2, X3) -&gt; any() record/3 record(X1, X2, X3) -&gt; any() record/4 record(X1, X2, X3, X4) -&gt; any() record_batch/3 record_batch(X1, X2, X3) -&gt; any() register_observer/3 register_observer(X1, X2, X3) -&gt; any() release/2 release(X1, X2) -&gt; any() set_observer_callback/3 set_observer_callback(X1, X2, X3) -&gt; any()"},{"ref":"otel_meter_provider.html","title":"otel_meter_provider","type":"extras","doc":"Module otel_meter_provider Function Index Function Details Behaviours: gen_server. This module defines the otel_meter_provider behaviour. Required callback functions: init/1, register_meter/3."},{"ref":"otel_meter_provider.html#function-index","title":"otel_meter_provider - Function Index","type":"extras","doc":""},{"ref":"otel_meter_provider.html#function-details","title":"otel_meter_provider - Function Details","type":"extras","doc":"handle_call/3 handle_call(Msg, From, State) -&gt; any() handle_cast/2 handle_cast(Msg, State) -&gt; any() init/1 init(X1) -&gt; any() register_application_meter/1 register_meter/2 start_link/2 start_link(ProviderModule, Opts) -&gt; any()"},{"ref":"otel_observer.html","title":"otel_observer","type":"extras","doc":"Module otel_observer Description Data Types An Observer is a callback based instrument with a LastValue aggregator. This module defines the otel_observer behaviour. Required callback functions: set_callback/3, observe/3."},{"ref":"otel_observer.html#description","title":"otel_observer - Description","type":"extras","doc":"On each collection cycle each Observer callback is run and passed an ObserverInstrument variable to use when observeing the new value, passing the ObserverInstrument, the new value and a list of attributes, key/value pairs."},{"ref":"otel_observer.html#data-types","title":"otel_observer - Data Types","type":"extras","doc":"callback() instrument() observer_instrument() observer_result()"},{"ref":"otel_propagator.html","title":"otel_propagator","type":"extras","doc":"Module otel_propagator Description Data Types Function Index Function Details Behaviour and API for propagation of Context. This module defines the otel_propagator behaviour. Required callback functions: inject/1, extract/2."},{"ref":"otel_propagator.html#description","title":"otel_propagator - Description","type":"extras","doc":"An implementation of the otel_propagator behaviour must implement the inject/1 and extract/2 callbacks. Inject is passed a term, for example the Span Context or Baggage, and returns a carrier, such as HTTP headers, to use for propagation in a request. Extract is passed the carrier, such as HTTP headers, and returns the term that will be set in the Context. Propagation API Specification: https://github.com/open-telemetry/opentelemetry-specification/blob/master/specification/context/api-propagators.md"},{"ref":"otel_propagator.html#data-types","title":"otel_propagator - Data Types","type":"extras","doc":"carrier() extractor() injector() text_map() text_map_extractor() text_map_injector()"},{"ref":"otel_propagator.html#function-index","title":"otel_propagator - Function Index","type":"extras","doc":""},{"ref":"otel_propagator.html#function-details","title":"otel_propagator - Function Details","type":"extras","doc":"text_map_extract/1 text_map_extract(TextMap) -&gt; any() text_map_inject/1 text_map_inject(TextMap) -&gt; any()"},{"ref":"otel_propagator_http_b3.html","title":"otel_propagator_http_b3","type":"extras","doc":"Module otel_propagator_http_b3 Function Index Function Details Behaviours: otel_propagator."},{"ref":"otel_propagator_http_b3.html#function-index","title":"otel_propagator_http_b3 - Function Index","type":"extras","doc":""},{"ref":"otel_propagator_http_b3.html#function-details","title":"otel_propagator_http_b3 - Function Details","type":"extras","doc":"extract/2 inject/1"},{"ref":"otel_propagator_http_w3c.html","title":"otel_propagator_http_w3c","type":"extras","doc":"Module otel_propagator_http_w3c Function Index Function Details Behaviours: otel_propagator."},{"ref":"otel_propagator_http_w3c.html#function-index","title":"otel_propagator_http_w3c - Function Index","type":"extras","doc":""},{"ref":"otel_propagator_http_w3c.html#function-details","title":"otel_propagator_http_w3c - Function Details","type":"extras","doc":"decode/1 decode(TraceContext) -&gt; any() encode/1 extract/2 inject/1"},{"ref":"otel_span.html","title":"otel_span","type":"extras","doc":"Module otel_span Description Data Types Function Index Function Details Span behaviour."},{"ref":"otel_span.html#data-types","title":"otel_span - Data Types","type":"extras","doc":"start_opts()"},{"ref":"otel_span.html#function-index","title":"otel_span - Function Index","type":"extras","doc":""},{"ref":"otel_span.html#function-details","title":"otel_span - Function Details","type":"extras","doc":"add_event/3 add_events/2 end_span/1 is_recording/1 set_attribute/3 set_attributes/2 set_status/2 span_id/1 trace_id/1 tracestate/1 update_name/2"},{"ref":"otel_sum_observer.html","title":"otel_sum_observer","type":"extras","doc":"Module otel_sum_observer Function Index Function Details Behaviours: otel_instrument, otel_observer."},{"ref":"otel_sum_observer.html#function-index","title":"otel_sum_observer - Function Index","type":"extras","doc":""},{"ref":"otel_sum_observer.html#function-details","title":"otel_sum_observer - Function Details","type":"extras","doc":"definition/1 definition/2 new/2 new/3 observe/3 set_callback/3"},{"ref":"otel_tracer.html","title":"otel_tracer","type":"extras","doc":"Module otel_tracer Data Types Function Index Function Details This module defines the otel_tracer behaviour. Required callback functions: start_span/3, start_span/4, with_span/3, with_span/4."},{"ref":"otel_tracer.html#data-types","title":"otel_tracer - Data Types","type":"extras","doc":"traced_fun() tracer_ctx()"},{"ref":"otel_tracer.html#function-index","title":"otel_tracer - Function Index","type":"extras","doc":""},{"ref":"otel_tracer.html#function-details","title":"otel_tracer - Function Details","type":"extras","doc":"add_event/2 add_events/1 current_span_ctx/0 current_span_ctx/1 end_span/0 non_recording_span/3 Returns a span_ctx record with is_recording set to false. This is mainly for use in propagators when they extract a Span to be used as a parent. set_attribute/2 set_attributes/1 set_current_span/1 set_current_span/2 set_status/1 start_span/3 start_span/4 text_map_propagators/1 update_name/1 with_span/3 with_span/4"},{"ref":"otel_tracer_noop.html","title":"otel_tracer_noop","type":"extras","doc":"Module otel_tracer_noop Function Index Function Details Behaviours: otel_tracer."},{"ref":"otel_tracer_noop.html#function-index","title":"otel_tracer_noop - Function Index","type":"extras","doc":""},{"ref":"otel_tracer_noop.html#function-details","title":"otel_tracer_noop - Function Details","type":"extras","doc":"add_event/4 add_events/3 end_span/2 set_attribute/4 set_attributes/3 set_status/3 start_span/3 start_span/4 update_name/3 with_span/3 with_span/4"},{"ref":"otel_tracer_provider.html","title":"otel_tracer_provider","type":"extras","doc":"Module otel_tracer_provider Function Index Function Details Behaviours: gen_server. This module defines the otel_tracer_provider behaviour. Required callback functions: init/1, register_tracer/3, resource/1."},{"ref":"otel_tracer_provider.html#function-index","title":"otel_tracer_provider - Function Index","type":"extras","doc":""},{"ref":"otel_tracer_provider.html#function-details","title":"otel_tracer_provider - Function Details","type":"extras","doc":"code_change/3 code_change(OldVsn, State, Extra) -&gt; any() handle_call/3 handle_call(Msg, From, State) -&gt; any() handle_cast/2 handle_cast(Msg, State) -&gt; any() init/1 init(X1) -&gt; any() register_application_tracer/1 register_tracer/2 resource/0 start_link/2 start_link(ProviderModule, Opts) -&gt; any()"},{"ref":"otel_updown_counter.html","title":"otel_updown_counter","type":"extras","doc":"Module otel_updown_counter Function Index Function Details Behaviours: otel_instrument."},{"ref":"otel_updown_counter.html#function-index","title":"otel_updown_counter - Function Index","type":"extras","doc":""},{"ref":"otel_updown_counter.html#function-details","title":"otel_updown_counter - Function Details","type":"extras","doc":"add/2 add/4 definition/1 definition/2 measurement/2 new/2 new/3"},{"ref":"otel_updown_sum_observer.html","title":"otel_updown_sum_observer","type":"extras","doc":"Module otel_updown_sum_observer Function Index Function Details Behaviours: otel_instrument, otel_observer."},{"ref":"otel_updown_sum_observer.html#function-index","title":"otel_updown_sum_observer - Function Index","type":"extras","doc":""},{"ref":"otel_updown_sum_observer.html#function-details","title":"otel_updown_sum_observer - Function Details","type":"extras","doc":"definition/1 definition/2 new/2 new/3 observe/3 set_callback/3"},{"ref":"otel_value_observer.html","title":"otel_value_observer","type":"extras","doc":"Module otel_value_observer Function Index Function Details Behaviours: otel_instrument, otel_observer."},{"ref":"otel_value_observer.html#function-index","title":"otel_value_observer - Function Index","type":"extras","doc":""},{"ref":"otel_value_observer.html#function-details","title":"otel_value_observer - Function Details","type":"extras","doc":"definition/1 definition/2 new/2 new/3 observe/3 set_callback/3"},{"ref":"otel_value_recorder.html","title":"otel_value_recorder","type":"extras","doc":"Module otel_value_recorder Function Index Function Details Behaviours: otel_instrument."},{"ref":"otel_value_recorder.html#function-index","title":"otel_value_recorder - Function Index","type":"extras","doc":""},{"ref":"otel_value_recorder.html#function-details","title":"otel_value_recorder - Function Details","type":"extras","doc":"definition/1 definition/2 measurement/2 new/2 new/3 record/2 record/4"}]